package
{
	import flash.display.Bitmap;
	import flash.display.NativeWindow;
	import flash.display.NativeWindowInitOptions;
	import flash.display.NativeWindowRenderMode;
	import flash.display.Sprite;
	import flash.geom.Rectangle;
	
	import starling.core.Starling;
	import starling.display.Image;
	import starling.events.Event;
	import starling.textures.Texture;

	public class TwoStarlingInTwoNativeWindows extends Sprite
	{
		// Embed demonstration icons
		[Embed(source="images/one.png")] public static const OneBitmap:Class;
		[Embed(source="images/two.png")] public static const TwoBitmap:Class;
		
		// Secondary window variables
		private var _secondWindow:NativeWindow;
		private var _secondStarling:Starling;
		
		public function TwoStarlingInTwoNativeWindows() {
			
			// Starling requires the windows to be in 'direct' render mode. 
			// This was done for the primary window through the use of the 
			// following instruction in the app's xml configuration file: 
			// <renderMode>direct</renderMode>. The following lines do the 
			// equivalent for the additional window.
			var nwio:NativeWindowInitOptions = new NativeWindowInitOptions();
			nwio.renderMode = NativeWindowRenderMode.DIRECT;
			_secondWindow = new NativeWindow(nwio);
			
			// Set window size and activate it (a window only shows up when 
			// activated).
			_secondWindow.bounds = new Rectangle(200, 200, 500, 250);
			_secondWindow.activate();
			
			// Primary stage is red and secondary stage is green
			stage.color = 0xC02A2A;
			_secondWindow.stage.color = 0x387D19;
			
			// Add a starling instance to the primary stage, start it and 
			// listen for creation of the root (usual stuff here).
			var _primaryStarling:Starling = new Starling(StarlingCanvas, stage);
			_primaryStarling.start();
			_primaryStarling.addEventListener(
				Event.ROOT_CREATED, 
				_onPrimaryStarlingReady
			);
			
		}
		
		public function _onPrimaryStarlingReady(e:Event):void {
			
			// Add the 'one' icon to the primary stage
			var sl:Starling = (e.currentTarget as Starling);
			sl.stage.addChild(getImage(OneBitmap));
			
			// This next line is key. If you try to setup the secondary 
			// Starling instance right away, you might crash or generate a 
			// Starling error [see for yourself by calling startSecondary() 
			// right away]. That's why it is being delayed a bit.
			Starling.current.juggler.delayCall(startSecondary, 1.5);
//			startSecondary();
			
		}
		
		public function startSecondary(e:Event = null):void {
			
			// Add a second Starling instance on the secondary stage, start 
			// it and wait for root creation (same as before).
			_secondStarling = new Starling(StarlingCanvas, _secondWindow.stage);
			_secondStarling.start();
			_secondStarling.addEventListener(Event.ROOT_CREATED, drawOnSecond);
			
		}
		
		public function drawOnSecond(e:Event):void {
			
			// Add the 'two' icon to the secondary stage
			(e.currentTarget as Starling).stage.addChild(getImage(TwoBitmap));
			
		}
		
		public function getImage(imageClass:Class):Image {
			var bitmap:Bitmap = new imageClass();
			return new Image(Texture.fromBitmap(bitmap));
		}
		
	}
	
}